      SUBROUTINE ANGLES(INUPH,DMAX,XYZ,XYZSIG)
C     **********************************************************
C     *            *********   TOFSTAN   *********             *
C     **********************************************************
C
C     MODIFIED VERSION OF PROGRAM STAN1 BY B. G. DEBOER THAT CALCULATES
C     DISTANCES AND ANGLES BOTH WITH ESD'S FROM THE FULL POSITIONAL
C     CORRELATION MATRIX (IF DESIRED).
C		NOW MODIFIED INTO SUBROUTINE ANGLE BY M. D. FIELD, DOES	NOT
C	NOT USE DISTANCE CALCULATION.
C
      include 'param.inc'
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      INTEGER LC
      REAL METRIC,DMAX,XYZ(MAXBAT,5),XYZSIG(MAXBAT,3)
      CHARACTER FNAME*64, FTEMP*64
      COMMON/A1/NATOMS,MAXPAR,SQDMAX,SQAMAX,NSYM,NCENT,ICNTL,ICOR,NLATT,
     1  TRNLM1,TRNLM2,TRNLM3,CELL(6),CELSTR(6),METRIC(3,3),CELCOV(6,6),
     2  DMTDCL(3,3,3),SYMMAT(3,3,96),SYMVEC(3,96),NAME(NATS),
     2  PARM(3,NATS)
c,CVMSTR(45150)
      COMMON /INTOTOF/ACELL(6),ACELCOV(6,6),ASIGCEL(NUPH,6)
      COMMON /COMUN/ SIGCEL(6),SIGPAR(3,NATS)
      COMMON /INOUT/ NOUT       !NIN,NOUT,NTAP,NTOF
      COMMON /ERRORC/ IERR, isig
      COMMON /FILEINT/LC,FNAME,FTEMP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      IERR=0
C      DIMENSION TITLE(20)
C-----
C      NIN = 5											  !TOFSTAN INPUT
      NOUT = 11										  !TOFSTAN OUTPUT
C      NTAP = 8										  !
C      NTOF = 18										  !TOFLS.STN FILE (WITH CORRELATION INFO)
C-VAX-
C-VAX-EQUIVALENCE LOGICAL UNIT NUMBERS TO GENERAL I/O FILES
C-VAX-FILES PERTINENT TO A SPECIFIC RUN ARE OPENED IN SETUP
C-VAX-
C      write(*,*) '*****************************************************'
C      write(*,*) '                     TOFSTAN v1.0'
C      write(*,*) '*****************************************************'
C      Z*,*) 'Enter filename (xxxxxxx.inp):'
C      read(*,'(A)') fname
C          i = 0
C   19     continue
C          i = i + 1
C          if ((fname(i:i).eq.' ').or.(i.eq.len(fname))) goto 21
C          goto 19
C   21     lc = i-1                  
C      OPEN (UNIT=5,file=fname(1:LC)//'.inp',STATUS='OLD')
C-VAX-
C      READ(NIN,1000) TITLE
C 1000 FORMAT(20A4)
C      WRITE(NOUT,1001) TITLE
C 1001 FORMAT(1H1,20A4///)
      MAXPAR=0
      MAXCOV=0
      AMAX = DMAX
      ICNTL = 1
      NATOMS = ABS(NATOM(INUPH))
      NSYM = MLT(INUPH)
      IF (ICET(INUPH).EQ.1) NCENT = 0
      IF (ICET(INUPH).EQ.2) NCENT = 1
      ICOR = 1
      IPOS = 0
      DO 161 ILL=1, NATOMS
          DO 162 IKK=1, 3
              PARM(IKK,ILL) = XYZ(ILL,IKK)
              SIGPAR(IKK,ILL) = XYZSIG(ILL,IKK)
C			This could be wrong!!!!!!!!!
C			NAME(ILL) = INT(ATEXT(INT(XYZ(ILL,4)+0.1)))
              NAME(ILL) = INT(XYZ(ILL,4)+0.1)
  162     CONTINUE
  161 CONTINUE
C
      IF (ICET(INUPH).EQ.2) THEN								!DO THIS IF CENTRO
      I8RC = 1
      DO I8R=1,NSYM                                                       !IRL= NUMBER OF SPACE GROUP OPERATIONS
          I8V=MOD(IVEC(INUPH,I8R)/32768/32**(3-1),32)
          A1 = I8V/9-1
          A2 = MOD(I8V/3,3)-1
          A3 = MOD(I8V,3)-1
          I8V=MOD(IVEC(INUPH,I8R)/32768/32**(3-2),32)
          B1 = I8V/9-1
          B2 = MOD(I8V/3,3)-1
          B3 = MOD(I8V,3)-1
          I8V=MOD(IVEC(INUPH,I8R)/32768/32**(3-3),32)
          C1 = I8V/9-1
          C2 = MOD(I8V/3,3)-1
          C3 = MOD(I8V,3)-1
          DET = A1*B2*C3-A1*B3*C2+A2*B3*C1-A2*B1*C3+A3*B1*C2-A3*B2*C1
          IF (DET.EQ.1) THEN
              SYMMAT(1,1,I8RC)=A1
          SYMMAT(1,2,I8RC)=A2
              SYMMAT(1,3,I8RC)=A3
              SYMMAT(2,1,I8RC)=B1
              SYMMAT(2,2,I8RC)=B2
              SYMMAT(2,3,I8RC)=B3
              SYMMAT(3,1,I8RC)=C1
              SYMMAT(3,2,I8RC)=C2
              SYMMAT(3,3,I8RC)=C3
              DO J = 1,3
                  SYMVEC(J,I8RC)=
     1            FLOAT(MOD(IVEC(INUPH,I8R)/32**(3-J),32)-16)/12.0
              ENDDO
              I8RC = I8RC + 1
          ENDIF
      ENDDO
      NSYM = NSYM/2 
      ENDIF
C
      IF (ICET(INUPH).EQ.1) THEN													!DO THIS IF NON-CENTRO.
      DO 163 I8R=1,NSYM                                                       !IRL= NUMBER OF SPACE GROUP OPERATIONS
          DO 301 J=1,3                                                        !UNPACK THE SYMMETRY MATRIXES
              I8V=IVEC(INUPH,I8R)/32768/32**(3-J)
              I8V=MOD(I8V,32)
              SYMMAT(J,1,I8R)=I8V/9-1
              SYMMAT(J,2,I8R)=MOD(I8V/3,3)-1
              SYMMAT(J,3,I8R)=MOD(I8V,3)-1
  301         SYMVEC(J,I8R)=
     1            FLOAT(MOD(IVEC(INUPH,I8R)/32**(3-J),32)-16)/12.0
  163 CONTINUE
      ENDIF


      DO 125 I= 1,6
          CELL(I)=ACELL(I)
  125 CONTINUE
      DO 126 I= 1,6
          DO 127 J= 1,6
              CELCOV(I,J)=ACELCOV(I,J)
  127     CONTINUE
  126 CONTINUE
      DO 129 J= 1,6
          SIGCEL(J)=ASIGCEL(INUPH,J)
  129 CONTINUE
      CALL SETUP(INUPH,DMAX,AMAX)
      IF(IERR.NE.0) GO TO 10
      IF(SQDMAX.LE.0.0) GO TO 10
C      WRITE(NOUT,1001) TITLE
      CALL DSTANG(INUPH)
   10 CONTINUE
C-VAX-
C-VAX-CLOSE ALL FILES PERTINENT TO A SPECIFIC RUN
C-VAX-
C      CLOSE (UNIT=5)
c      CLOSE (UNIT=6)
      IF(ICNTL.EQ.0) GO TO 20
C      IF(IPOS.LE.0.OR.ICOR.GT.0) CLOSE (UNIT=8)
      GO TO 30
   20 CONTINUE
C      CLOSE (UNIT=18)
   30 CONTINUE
C-VAX-
      RETURN
      END


      SUBROUTINE MULTI(ANS,A1,A2,A3,II,JJ,KK,LL)
      DIMENSION ANS(II,LL),A1(II,JJ),A2(JJ,KK),A3(LL,KK)
      DO 10 I=1,II
      DO 10 L=1,LL
      ANS(I,L) = 0.0
      DO 10 J=1,JJ
      DO 10 K=1,KK
      ANS(I,L) = ANS(I,L) + A1(I,J)*A2(J,K)*A3(L,K)
C        *** NOTE ***  TRANSPOSE OF A3  (NO EFFECT IF VECTOR OR SCALAR)
   10 CONTINUE
      RETURN
      END


      SUBROUTINE PULCOV(COVMAT,IA,IB,IOF)
      INCLUDE 'param.inc'
      DIMENSION COVMAT(3,3)
C
      COMMON/F2/SIGCEL(NUPH,6),SIGATOM(NATS,3)
      COMMON/F3/RJAC(MSZ,MSZ)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES

      DO K1=1,3
        DO K2=1,3                       
           KI = LP(IOF+IA,K1)
           KJ = LP(IOF+IB,K2)
           IF ((K1.EQ.K2).AND.(IA.EQ.IB)) THEN
              COVMAT(K1,K2) = 1.0*SIGATOM(IA,K1)*SIGATOM(IB,K2)
           ELSE             
              IF ((KI.NE.0).AND.(KJ.NE.0).AND.(KI.LE.MAXS).AND.
     *            (KJ.LE.MAXS)) THEN
               COVMAT(K1,K2)=ABS(RJAC(KI,KJ)/SQRT(RJAC(KI,KI)*
     *         RJAC(KJ,KJ))*SIGATOM(IA,K1)*SIGATOM(IB,K2))
              ELSE
               COVMAT(K1,K2) = 0.0
              ENDIF
           ENDIF
        ENDDO
      ENDDO
      RETURN
      END



      SUBROUTINE SETUP(IPHNUM,DMAX,AMAX)
      include 'param.inc'
      CHARACTER FNAME*64,FTEMP*64,SYMB(NUPH,20)*1,TITLE*80,
     1 PHSNM(NUPH)*80
      REAL METRIC,DMAX
C
      COMMON/F3/RJAC(MSZ,MSZ)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES
C
      COMMON/A1/NATOMS,MAXPAR,SQDMAX,SQAMAX,NSYM,NCENT,ICNTL,ICOR,
     1  NLATT,TRNLM1,TRNLM2,TRNLM3,CELL(6),CELSTR(6),METRIC(3,3),
     2  CELCOV(6,6),DMTDCL(3,3,3),SYMMAT(3,3,96),SYMVEC(3,96),
     3  NAME(NATS),PARM(3,NATS)
C,CVMSTR(45150)
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON /COMUN/ SIGCEL(6),SIGPAR(3,NATS)
      COMMON /INOUT/ NOUT ! NIN,NOUT,NTAP,NTOF
      COMMON /ERRORC/ IERR, isig
      COMMON /FILEINT/LC,FNAME,FTEMP
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
C      DIMENSION CODE1(4),CODE2(4),CORIN(4),
C     1  OUTMAT(3,3,7),NAMOUT(7),SIGB(6)
      DIMENSION OUTMAT(3,3,7),NAMOUT(7)
C      DIMENSION LCENT(9), LETTR(4)
C      LOGICAL LETTR
      CHARACTER*1 LCENT(9),ILATT,LETTR(4)
      DATA LETTR/'X','Y','Z',' '/
C        4TH LETTR IS A DUMMY TO KEEP MEMORY IN  4-BYTE BLOCKS
      DATA LCENT/' ','P','A','B','C','F','I','R','H'/
      DATA MXAT/NATS/,MXSY/96/
      isig= 0
C-----
      NCVOUT = 1
      NCLCOR = 1
      DEG = 3.1415926/180.0
      DO 172 I=1,9
          IF (SYMB(IPHNUM,1) .EQ. LCENT(I)) THEN
              ILATT = LCENT(I)
c              write(7,*) 'Now',i,SYMB(iphnum,1), '-',LCENT(i)
          ENDIF
  172 CONTINUE
C-----	 Fix this bit up!!!!!!!!!!!!!!!!
C      READ(NIN,1000) DMAX,AMAX,ICNTL,ILATT,NCVOUT,NCLCOR,NATOMS,NSYM,
C     1 NCENT,ICOR,IPOS
C 1000 FORMAT(2F10.5,I5,4X,A1,10I5)
C-VAX-
C-VAX-OPEN CODED POSITION AND CORRELATION MATRIX FILES (FROM 
C-VAX-LSHF OR TOFLS), IF NECESSARY
C-VAX-
C      IF(ICNTL.EQ.0) GO TO 2
C      IF(IPOS.LE.0.OR.ICOR.GT.0) THEN
C		OPEN(UNIT=8,file=fname(1:LC)//'.8',STATUS='OLD')
C      ENDIF
C	GO TO 3
C    2 CONTINUE
C      OPEN(UNIT=18,FILE=Fname(1:LC)//'.STN',STATUS='OLD')
C    3 CONTINUE
C-VAX-
      IF(AMAX.GT.DMAX) AMAX = DMAX
C      WRITE(NOUT,1000) DMAX,AMAX,ICNTL,ILATT,NCVOUT,NCLCOR,NATOMS,NSYM,
C     1 NCENT,ICOR,IPOS
      DO 4 I=1,9
      IF (ILATT.EQ.LCENT(I)) GO TO 5
    4 CONTINUE
      WRITE(NOUT,1080) ILATT
 1080 FORMAT('   ***',2X,A2,' IS NOT A RECOGNIZED LATTICE CENTERING',
     1 ' SYMBOL -- PROGRAM ABORT  ***')
      IERR=1
      RETURN
    5 CONTINUE
      NLATT=I
      IF(ILATT.EQ.LCENT(1)) ILATT=LCENT(2)
      IF(ICNTL.NE.0) GO TO 6
      CALL TOFSTN(MAXCOV)
      IF(IERR.NE.0) RETURN
C      CALL LATCEN
    6 CONTINUE
      WRITE(NOUT,1001) IPHNUM,NATOMS,DMAX,AMAX,NSYM
 1001 FORMAT(/,15X,'********** PHASE ',I1,' **********',/,/,
     1       15X,'NUMBER OF ATOMS    = ',I5,/,
     2       15X,'MAXIMUM DISTANCE   = ',F8.5,/
     3       15X,'MAXIMUM ANGLE CALC = ',F8.5,/,
     4       15X,'NUMBER OF SYM. OP. = ',I5)
      IF(ICNTL.EQ.0) GO TO 101
      IF(NATOMS.GT.MXAT) GO TO 70
C	   THIs Is Questionable
C
C      IF(NSYM.GT.MXSY) GO TO 75
  101 CONTINUE
      IF(NCENT.GT.0) WRITE(NOUT,1002)
 1002 FORMAT(15X,'  -PLUS AN INVERSION AT THE ORIGIN'/)
C      IF(NCLCOR.GT.0) WRITE(NOUT,1003)
C 1003 FORMAT('0   READ IN CELL-DIMENSIONS CORRELATION MATRIX')
C      REWIND NTAP
      IF(DMAX.LT.0.0) DMAX = 0.0
      IF(AMAX.LT.0.0) AMAX = 0.0
      SQDMAX = DMAX*DMAX
      SQAMAX = AMAX*AMAX
C      IF(ICNTL.EQ.0) GO TO 100
C
C			Again input from other program!!!!!!!
C      READ(NIN,1010) CELL,SIGCEL
C 1010 FORMAT(6F10.5/6F10.5)
C  100 CONTINUE
      do i=1,6
       if(sigcel(i).ne.0.0) isig=isig+1
      end do
      WRITE(NOUT,1011) CELL,SIGCEL
 1011 FORMAT(' CELL DIMS. =',6F10.5/'     SIGMAS =',6F10.5///)
      IF(CELL(4).LE.1.0) GO TO 11
      DO 10 I=4,6
      CELL(I) = COS(CELL(I)*DEG)
   10 SIGCEL(I) = SIGCEL(I)*DEG*SQRT(1.0-CELL(I)*CELL(I))
C      WRITE(NOUT,1011) CELL,SIGCEL
   11 Q = SQRT(1.0-CELL(4)*CELL(4))
      QQ = SQRT(1.0-CELL(5)*CELL(5))
      QQQ = SQRT(1.0-CELL(6)*CELL(6))
      CELSTR(4) = (CELL(5)*CELL(6)-CELL(4))/(QQ*QQQ)
      CELSTR(5) = (CELL(4)*CELL(6)-CELL(5))/(Q*QQQ)
      CELSTR(6) = (CELL(4)*CELL(5)-CELL(6))/(Q*QQ)
      Q4 = SQRT(1.0+2.0*CELL(4)*CELL(5)*CELL(6) - CELL(4)*CELL(4)
     1   - CELL(5)*CELL(5) - CELL(6)*CELL(6) )
      CELSTR(1) =   Q/(Q4*CELL(1))
      CELSTR(2) =  QQ/(Q4*CELL(2))
      CELSTR(3) = QQQ/(Q4*CELL(3))
      TRNLM1 = IFIX(DMAX*CELSTR(1)+0.5)
      TRNLM2 = IFIX(DMAX*CELSTR(2)+0.5)
      TRNLM3 = IFIX(DMAX*CELSTR(3)+0.5)
      DO 12 I=1,3
      DO 12 J=1,3
      K = 9 - I - J
      IF(I.EQ.J) METRIC(I,J) = CELL(I)*CELL(I)
      IF(I.NE.J) METRIC(I,J) = CELL(I)*CELL(J)*CELL(K)
   12 CONTINUE
      WRITE(NOUT,1100) ((METRIC(I,J),J=1,3),I=1,3)
 1100 FORMAT(1H ,20X,'METRIC TENSOR'//3(14X,F8.3,1X,F8.3,1X,F8.3/))
      IF(ICNTL.EQ.0) GO TO 120
C      DO 13 I=1,6
C      DO 13 J=I,6
C      CELCOV(I,J) = 0.0
C      IF(I.EQ.J) CELCOV(I,J) = 1.0
   13 CONTINUE
C      IF(NCLCOR.LE.0) GO TO 14
C		Again do this!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C      READ(NIN,1012) (CELCOV(1,J),J=2,6),(CELCOV(2,J),J=3,6),
C     1  (CELCOV(3,J),J=4,6),(CELCOV(4,J),J=5,6),CELCOV(5,6)
C 1012 FORMAT(8F10.5/7F10.5)
C   14 DO 15 I=1,5
C      NQ = I + 1
C      DO 15 J=NQ,6
C   15 CELCOV(J,I) = CELCOV(I,J)
  120 CONTINUE
      WRITE(NOUT,1013) ((CELCOV(I,J),J=1,6),I=1,6)
 1013 FORMAT(1H ,15X,'UNIT-CELL CORRELATION MATRIX'//6(6F10.5/)///)
      DO 16 I=1,6
      DO 16 J=1,6
  16  CELCOV(I,J) = SIGCEL(I)*SIGCEL(J)*CELCOV(I,J)
      DO 17 K=1,3
      Q = CELL(K)
      DO 17 I=1,3
      DO 17 J=1,3
      IF(I.EQ.K.OR.J.EQ.K) DMTDCL(I,J,K) = METRIC(I,J)/Q
      IF(I.NE.K.AND.J.NE.K) DMTDCL(I,J,K) = 0.0
   17 CONTINUE
      DO 18 I=1,3
   18 DMTDCL(I,I,I) = 2.0*DMTDCL(I,I,I)
C              DMTDCL IS DERIVATIVE OF METRIC W.R.T. CELL DIMS.
      IF(ICNTL.EQ.0) GO TO 30
C      CALL TRANDB(SYMMAT,SYMVEC,NSYM)
      IF(IERR.NE.0) RETURN
C      CALL LATCEN
      GO TO (25,25,23,23,23,23,23,25,24), NLATT
   23 CONTINUE
C      WRITE(NOUT,1081) ILATT,NSYM
C 1081 FORMAT('0     PLUS THOSE RELATED BY ',A2,'-CENTERING, MAKING',
C     1 I3,' EQUIVALENT POSITIONS IN ALL')
      GO TO 25
   24 CONTINUE
C      WRITE(NOUT,1082) NSYM
C 1082 FORMAT('0     PLUS THOSE FROM A HEXAGONAL SETTING OF THE RHOMBO',
C     1 'HEDRAL CELL, MAKING',I3,' EQUIVALENT POSITIONS IN ALL')
   25 CONTINUE
C      WRITE(NOUT,1083)
      DO 22 K=1,NSYM
C      WRITE(NOUT,1084) K,((SYMMAT(I,J,K),J=1,3),I=1,3),(SYMVEC(I,K),
C     1 I=1,3)
   22 CONTINUE
      MAXPAR = 3*NATOMS
      MAXCOV = (MAXPAR*MAXPAR+MAXPAR)/2
      WRITE(NOUT,1014)
 1014 FORMAT (1H /'   NO.  NAME      ATOM PARAMETERS')
C      IF(IPOS) 19,19,20
C     READ ATOM PARMS IF FROM TAPE8  (PRODUCED BY LSHF)
C   19 READ(NTAP,1015) ((PARM(I,IA),I=1,3),(SIGPAR(I,IA),I=1,3),NAME(IA),
C     1 IA=1,NATOMS)
C 1015 FORMAT(6F10.7,16X,A4)
      GO TO 21
C GET from other thing!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     READ ATOM PARM FROM CARDS (LSHF PUNCHED OUTPUT)
C   20 READ(NIN,1015) ((PARM(I,IA),I=1,3),(SIGPAR(I,IA),I=1,3),NAME(IA),
C     1 IA=1,NATOMS)
   21  continue    
       do ia=1,natoms
         do i=1,3
           if(sigpar(i,ia).ne.0.0) isig=isig+1
         end do
       end do
      WRITE(NOUT,1016)(IA,ATEXT(NAME(IA)),(PARM(I,IA),I=1,3),
     1 (SIGPAR(I,IA),I=1,3),IA=1,NATOMS)
 1016 FORMAT(1H ,I5,2X,A4,3X,3F10.7/15X,3F10.7)
      if(isig.eq.0) icor = 0
      GOTO 30
      IF(ICOR.LE.0) GO TO 26
C     READ CORRELATION MATRIX FROM TAPE8 (PRODUCED BY LSHF)
C      READ(NTAP,2001) I
C 2001 FORMAT(I10)
C      IF(I.EQ.MAXCOV) GO TO 241
C      WRITE(NOUT,2002)
C 2002 FORMAT('0***** WRONG NUMBER OF CORRELATION ENTRIES ON UNIT8',
C     1 ' - PROGRAM ABORT. *****')
C      IERR=1
C      RETURN
C  241 READ(NTAP,2003) (CVMSTR(I),I=1,MAXCOV)
C 2003 FORMAT(16F5.2)
C
C     OLD PATCH FOR CORRECTING CORRELATION COEFFICIENTS FOR CONSTRAINED
C     PARAMETERS MISHANDLED BY LSHF.
C     NOT REALLY USED ANYMORE, BUT KEPT IN JUST IN CASE.
C
C
C      IXA=1
C      IXB=2
C	GET from other file!!!!!!!!!!!!!!
C  242 READ(NIN,2004,END=35) IA,IB
C      WRITE(NOUT,2004) IA,IB
C 2004 FORMAT(2I10)
C242   IF(IA.LT.IXA) GO TO 245
C      IF(IB.LE.IXB) GO TO 245
C      IF(IB.LE.IA) GO TO 245
C      IXA=IA
C      IXB=IB
C      IA=3*(IA-1)
C      IB=3*(IB-1)
C      NQ=IB-IA
C      DO 244 I=1,3
C      IA=IA+1
C      IB=IB+1
C      INDX = (IA-1)*MAXPAR - (IA-3)*IA/2
C      K=MAXPAR-IA
C      IHOLD = (IA-1)*MAXPAR - (IA-1)*IA/2 + IB
C      DO 243 J=1,NQ
C      CVMSTR(IHOLD)=CVMSTR(INDX)
C      INDX=INDX+1
C      IHOLD=IHOLD+K
C  243 K=K-1
C  244 CONTINUE
C      GO TO 242
C  245 NSYM=999
C      GO TO 242
C     END PATCH.
C-----
   26 CONTINUE
C      N=1
C      ILOC=0
C   27 CONTINUE
C      IF(N.GT.MAXPAR) GO TO 35
C      DO I=N,MAXPAR
C C     ILOC=ILOC+1
C      IF(I.EQ.N) then
C      CVMSTR(ILOC)=1.0
C      GO TO 29
C   28 else
C      CVMSTR(ILOC)=0.0
C   29 end if
C      end do
C      N=N+1
C      GO TO 27
   30 CONTINUE
CC      WRITE(NOUT,1083)
C 1083 FORMAT(1H0,40X,'THE EQUIVALENT POSITIONS ARE:'/42X,
C     1 'SYMMETRY MATRIX',25X,'TRANSLATION VECTOR')
C      DO 31 K=1,NSYM
C      WRITE(NOUT,1084) K,((SYMMAT(I,J,K),J=1,3),I=1,3),(SYMVEC(I,K),
C     1 I=1,3)
C 1084 FORMAT('0 POSITION',I3,10X,9F6.1,3F10.5)
C   31 CONTINUE
C      WRITE(NOUT,1014)
C      WRITE(NOUT,1016) (IA,NAME(IA),(PARM(I,IA),I=1,3),
C     1 (SIGPAR(I,IA),I=1,3),IA=1,NATOMS)
   35 CONTINUE
      IF(ICOR) 55,55,36
   36 CONTINUE
      IF (NCVOUT.LE.0) GO TO 45
      WRITE(NOUT,1022)
 1022 FORMAT(1H /' ATOMIC-POSITIONS CORRELATIONS OF MAGNITUDE NOT LESS',
     1'THAN 0.1 ARE ... ')
      NQ = MAXPAR - 1

         
      IOF = 0                                                                         !FOR MORE THAN 1 PHASE
      IF (IPHNUM.GT.1) THEN
        DO I=1,IPHNUM-1
          IOF = IOF + ABS(NATOM(I))
        ENDDO
      ENDIF
      DO I=1,NATOM(IPHNUM)
      DO J=1,NATOM(IPHNUM)
          DO K1=1,3
          DO K2=1,3                       
              KI = LP(IOF+I,K1)
              KJ = LP(IOF+J,K2)
              IF ((KI.NE.0).AND.(KJ.NE.0).AND.(KI.LE.MAXS).AND.
     *            (KJ.LE.MAXS)) THEN
                  TEMPCOL =RJAC(KI,KJ)/SQRT(RJAC(KI,KI)*RJAC(KJ,KJ))
                  IF (abs(TEMPCOL).GT.0.1) THEN
      WRITE(NOUT,1021) LETTR(K1),ATEXT(NAME(I)),LETTR(K2),
     *ATEXT(NAME(J)),TEMPCOL
                  ENDIF
               ENDIF
             ENDDO
             ENDDO
          ENDDO
      ENDDO

CBH      DO 40 I=1,NQ
CBH      K = I + 1
CBH    DO 40 J=K,MAXPAR
CBH      INDX = (I-1)*MAXPAR + J - (I*(I-1))/2
CBH      IF( ABS(CVMSTR(INDX)) .LT. 0.1) GO TO 40
CBH      IA = (I-1)/3
CBH      IXA = I - 3*IA
CBH      IA = IA + 1
CBH      IB = (J-1)/3
CBH      IXB = J - 3*IB
CBH      IB = IB + 1
C      WRITE(NOUT,1021) LETTR(IXA),NAME(IA),LETTR(IXB),NAME(IB),
C     1  CVMSTR(INDX)
 1021 FORMAT(4X,A1,'(',A4,') - ',A1,'(',A4,')',F6.2)
CBH   40 CONTINUE
C      WRITE(NOUT,1023)
C 1023 FORMAT('0ALL OTHERS HAVE MAGNITUDES LESS THAN 0.10')
      GO TO 55
   45 WRITE(NOUT,1024)
 1024 FORMAT(1H /1h ,42X,'COMPLETE ATOMIC-POSITIONS CORRELATIONS MATRIX'
     1  //)
C   45	IA=1
C      DO 50 IA=1,NATOMS
C      IB = IA - 1
C   47 K = 0
C   48 IB = IB + 1
C      K = K + 1
C      CALL PULCOV(OUTMAT(1,1,K),CVMSTR,MAXPAR,IA,IB)
C      NAMOUT(K) = NAME(IB)
C      IF(K.LT.7.AND.IB.LT.NATOMS) GO TO 48
C      WRITE(NOUT,1025) (NAMOUT(I),I=1,K)

C 1025 FORMAT('0   ',7(13X,A4))
C      DO 49 I=1,3

C   49 WRITE(NOUT,1026) NAME(IA),((OUTMAT(I,J,L),J=1,3),L=1,K)
C 1026 FORMAT(4X,A4,2X,7(2X,3F5.2))
C      IF(IB.LT.NATOMS) GO TO 47
C      WRITE(NOUT,1027)
C 1027 FORMAT('0********************')
   50 CONTINUE
      GO TO 57
   55 CONTINUE
C      WRITE(NOUT,1028)
C 1028 FORMAT(1H /'  NO ATOMIC-POSITIONS CORRELATIONS ARE INCLUDED IN ',
C     1 'THE CALCULATIONS')
   57 CONTINUE
C     DO 60 IA=1,NATOMS
C C     DO 60 NQ=1,3
C C     I = 3*IA + NQ - 3
C      DO 60 IB=IA,NATOMS
C      DO 60 NQQ=1,3
C      J = 3*IB + NQQ - 3
C      IF(I.GT.J) GO TO 60
C      INDX = (I-1)*MAXPAR + J - (I*(I-1))/2
C      CVMSTR(INDX) = CVMSTR(INDX)*SIGPAR(NQ,IA)*SIGPAR(NQQ,IB)
C   60 CONTINUE
      RETURN
   70 WRITE(NOUT,1070) MXAT
 1070 FORMAT('- FORGET IT....CANNOT HOLD CORRELATIONS FOR MORE THAN',I3,
     1 ' ATOMS')
      IERR=1
      RETURN
   75 WRITE(NOUT,1075) MXSY
 1075 FORMAT('- CANNOT TAKE MORE THAN ',I2,' SYMMETRY ELEMENTS')
      IERR=1
      RETURN
      END
      
C      SUBROUTINE TRANDB(SYMMAT,SYMVEC,NSYM)
C      COMMON /INOUT/ NOUT ! NIN,NOUT,NTAP,NTOF
C      COMMON /ERRORC/ IERR, isig
C      DIMENSION SYMMAT(3,3,96),SYMVEC(3,96),XNUM(2)
C      DIMENSION CHAR(40),NUM(9),LETTR(3)
C      INTEGER CHAR,BLANK,NUM,ZERO,SLASH,LETTR,PLUS,PAND,MINUS,COMMA
C      DATA BLANK/'  '/,NUM/'1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 '/
C     1,ZERO/'0 '/,SLASH/'/ '/,LETTR/'X ','Y ','Z '/,PLUS/'+ '/,
C     2 PAND/'& '/,MINUS/'- '/,COMMA/', '/
C      DO 1 NN=1,NSYM
C      DO 1 I=1,3
C      SYMVEC(I,NN) = 0.0
C	DO 1 J=1,3
C     1 SYMMAT(I,J,NN) = 0.0
C	   DO 100 NN=1,NSYM
C		Get from files!!!!!!!!!!!!!!!!!!!!!11
C      READ(NIN,1000) CHAR
C 1000 FORMAT(40A1)
C      WRITE(NOUT,1001) NN,CHAR
C 1001 FORMAT(1H0,I3,2X,40A1)
C      SIGN = 1.0
C      XNUM(1) = 0.0
C      XNUM(2) = 0.0
C      IROW = 1
C      KK = 1
C      DO 90 I=1,40
C      IF(CHAR(I).EQ.BLANK) GO TO 90
C	  DO 5 J=1,9
C      IF(CHAR(I).NE.NUM(J)) GO TO 5
C      XNUM(KK) = 10.0*XNUM(KK) + FLOAT(J)
C      GO TO 90
C    5 CONTINUE
c      IF(CHAR(I).NE.ZERO) GO TO 6
c      XNUM(KK) = 10.0*XNUM(KK)
C      GO TO 90
C    6 IF(CHAR(I).NE.SLASH) GO TO 7
C      IF(KK.NE.1) GO TO 80
C      KK = 2
C      GO TO 90
C    7 DO 8 J=1,3
c      IF(CHAR(I).NE.LETTR(J)) GO TO 8
C      IF(XNUM(2).NE.0.0.OR.KK.NE.1) GO TO 80
c      IF(XNUM(1).EQ.0.0) XNUM(1) = 1.0
c      SYMMAT(IROW,J,NN) = SIGN*XNUM(1)
c      XNUM(1) = 0.0
c      SIGN = 1.0
c      GO TO 90
c    8 CONTINUE
c      IF(CHAR(I).NE.PLUS.AND.CHAR(I).NE.PAND) GO TO 10
c      IF(KK.EQ.1.AND.XNUM(1).EQ.0.0.AND.XNUM(2).EQ.0.0) GO TO 9
c      IF(KK.EQ.2.AND.XNUM(2).EQ.0.0) GO TO 80
c      IF(XNUM(2).EQ.0.0) XNUM(2) = 1.0
c      SYMVEC(IROW,NN) = SIGN*XNUM(1)/XNUM(2)
c      KK = 1
c      XNUM(1) = 0.0
c      XNUM(2) = 0.0
c    9 SIGN = 1.0
c      GO TO 90
c   10 IF(CHAR(I).NE.MINUS) GO TO 12
c      IF(KK.EQ.1.AND.XNUM(1).EQ.0.0.AND.XNUM(2).EQ.0.0) GO TO 11
c      IF(KK.EQ.2.AND.XNUM(2).EQ.0.0) GO TO 80
c      IF(XNUM(2).EQ.0.0) XNUM(2) = 1.0
c      SYMVEC(IROW,NN) = SIGN*XNUM(1)/XNUM(2)
c      KK = 1
c      XNUM(1) = 0.0
c      XNUM(2) = 0.0
c   11 SIGN = -1.0
c      GO TO 90
c   12 IF(CHAR(I).NE.COMMA) GO TO 80
c      IF(KK.EQ.1.AND.XNUM(1).EQ.0.0.AND.XNUM(2).EQ.0.0) GO TO 13
c      IF(KK.EQ.2.AND.XNUM(2).EQ.0.0) GO TO 80
c      IF(XNUM(2).EQ.0.0) XNUM(2) = 1.0
c      SYMVEC(IROW,NN) = SIGN*XNUM(1)/XNUM(2)
c      KK = 1
c      XNUM(1) = 0.0
c      XNUM(2) = 0.0
c   13 SIGN = 1.0
c      IROW = IROW + 1
c      IF(IROW.LE.3) GO TO 90
c   80 WRITE(NOUT,1002) I
c 1002 FORMAT('0ERROR DETECTED AT OR BEFORE COL.',I3,10X,'*** PROGRAM STO
C     1P ***')
c      IERR = 1
c      GO TO 100
c   90 CONTINUE
C
C      IF(IROW.EQ.3) GO TO 95
C      WRITE(NOUT,1004)
C 1004 FORMAT(' MISSING OR EXCESS COMMAS')
C   92 NM = 999
C      WRITE(NOUT,1002) NM
C      IERR = 1
C      GO TO 101
C   95 IF(KK.EQ.1.AND.XNUM(1).EQ.0.0.AND.XNUM(2).EQ.0.0) GO TO 99
C      IF(KK.EQ.2.AND.XNUM(2).EQ.0.0) GO TO 92
C      IF(XNUM(2).EQ.0.0) XNUM(2) = 1.0
C      SYMVEC(IROW,NN) = SIGN*XNUM(1)/XNUM(2)
C   99 CONTINUE
C  100 CONTINUE
C  101 CONTINUE
C      RETURN
C      END

      SUBROUTINE DSTANG(INUPH)
      include 'param.inc'
      REAL METRIC
      COMMON/A1/NATOMS,MAXPAR,SQDMAX,SQAMAX,NSYM,NCENT,ICNTL,ICOR,
     1  NLATT,TRNLM1,TRNLM2,TRNLM3,CELL(6),CELSTR(6),METRIC(3,3),
     2  CELCOV(6,6),DMTDCL(3,3,3),SYMMAT(3,3,96),SYMVEC(3,96),
     3  NAME(NATS),PARM(3,NATS)
C,CVMSTR(45150)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON /INOUT/ NOUT ! NIN,NOUT,NTAP,NTOF
      COMMON /ERRORC/ IERR,isig
      DIMENSION XB1(3),XC1(3),XB2(3),DEL1(3),DELAB(3),DELAC(3),DQDPAR(9)
     1,DQDA(3),DQDB(3),DQDC(3),DCOV(6,6),ACOV(9,9),ERVECB(3),ERVECC(3),
     2 QMAT(3,3),QQMAT(3,3),NATSTO(NATS),NSYSTO(NATS),DSQSTO(NATS),
     3  XBSTO(3,NATS)
      EQUIVALENCE (DQDPAR(1),DQDA(1)),(DQDPAR(4),DQDB(1)),(DQDPAR(7),
     1  DQDC(1))
      DIMENSION UNITM(3,3)
      dimension check(MAXBONDS,4),testang(MAXBONDS,7)
      real*8 namecheck,ln1,ln2
      REAL UNITM
      DATA UNITM/1.0,0.0,0.0,  0.0,1.0,0.0,  0.0,0.0,1.0/
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
C            FOLLOWING STATEMENTS NEEDED TO ESTABLISH ADDRESSES SO ...
      flag = 0
      UNITS = 1.0
      PARSIG = 0.0
      CELSIG = 0.0
      DSQAB = 0.0
      DOT = 0.0
      IOF = 0
      IF (INUPH.GT.1) THEN
          DO I=1,INUPH-1
              IOF = IOF+NATOM(I)
          ENDDO
      ENDIF
C            ... THAT SUBRT. MULT CAN WORK WITH THEM
      RAD = 180.0/3.1415926
C
      DO 400 IA=1,NATOMS

      if(isig.ne.0) then
         WRITE(NOUT,1000) ATEXT(NAME(IA)),(PARM(I,IA),I=1,3)
      else
         write(nout,2000) ATEXT(name(ia)),(parm(i,ia),i=1,3)
      end if 
 1000 FORMAT(1H /'  ATOM1 - ATOM2  DIST.   SIGMA'/'  ',A4,' -',26X,'AT 
     1INPUT = (',3F8.4,')' )
 2000 FORMAT(1H /'  ATOM1 - ATOM2  DIST.        '/'  ',A4,' -',26X,'AT 
     1INPUT = (',3F8.4,')' )
      do iii = 1,4
         do iiii = 1,500
            check(iiii,iii)=0
         end do
      end do
      iii=1
      max=1
      if(isig.ne.0) then
C       CALL PULCOV(QMAT,CVMSTR,MAXPAR,IA,IA)
       CALL PULCOV(QMAT,IA,IA,IOF)
       DO 10 I=1,3
       DO 10 J=1,3
   10  DCOV(I,J) = QMAT(I,J)
      end if
      NUMSTO = 0
      DO 200 IB=1,NATOMS
      DO 200 ISYM=1,NSYM
      CALL MULTI(XB1,SYMMAT(1,1,ISYM),PARM(1,IB),UNITS,3,3,1,1)                !GENERATE NEXT X,Y,Z POS
      DO 20 I=1,3
   20 XB1(I) = XB1(I) + SYMVEC(I,ISYM)                                        !ADD TRANSLATIONAL VEC
      ICENT = 0
   30 DO 40 I=1,3
      DEL1(I) = XB1(I) - PARM(I,IA)
   31 IF(DEL1(I).LE.0.5) GO TO 32                                             ! DELX = X1 - X2
      XB1(I) = XB1(I) - 1.0
      DEL1(I) = DEL1(I) - 1.0
      GO TO 31
   32 IF(DEL1(I).GT.-0.5) GO TO 40
      XB1(I) = XB1(I) + 1.0
      DEL1(I) = DEL1(I) + 1.0
      GO TO 32
   40 CONTINUE
      TRNDX1 = -TRNLM1
   41 XB2(1) = XB1(1) + TRNDX1
      DELAB(1) = DEL1(1) + TRNDX1
      TRNDX2 = -TRNLM2
   42 XB2(2) = XB1(2) + TRNDX2
      DELAB(2) = DEL1(2) + TRNDX2
      TRNDX3 = -TRNLM3
   43 XB2(3) = XB1(3) + TRNDX3
      DELAB(3) = DEL1(3) + TRNDX3
      CALL MULTI(DSQAB,DELAB,METRIC,DELAB,1,3,3,1)

      IF(DSQAB.LT.0.0001.OR.DSQAB.GT.SQDMAX) GO TO 100
          if(isig.ne.0) then
          CALL MULTI(DQDB,METRIC,DELAB,UNITS,3,3,1,1)
          DO 50 I=1,3
              DQDB(I) = 2.0*DQDB(I)
   50     DQDA(I) = -DQDB(I)
C          CALL PULCOV(QMAT,CVMSTR,MAXPAR,IA,IB)
          CALL PULCOV(QMAT,IA,IB,IOF)
          CALL MULTI(QQMAT,UNITM,QMAT,SYMMAT(1,1,ISYM),3,3,3,3)
          IF(ICENT.LE.0) GO TO 59
          DO 55 I=1,3
          DO 55 J=1,3
   55     QQMAT(I,J) = -QQMAT(I,J)
   59     DO 60 J=1,3
              K = J + 3
              DO 60 I=1,3
                  DCOV(I,K) = QQMAT(I,J)
   60     DCOV(K,I) = QQMAT(I,J)
C          CALL PULCOV(QMAT,CVMSTR,MAXPAR,IB,IB)
          CALL PULCOV(QMAT,IB,IB,IOF)
          CALL MULTI(QQMAT,SYMMAT(1,1,ISYM),QMAT,SYMMAT(1,1,ISYM)
     1    ,3,3,3,3)
          DO 70 J=1,3
              K = J + 3
              DO 70 I=1,3
                  L = I + 3
   70     DCOV(L,K) = QQMAT(I,J)
          CALL MULTI(PARSIG,DQDPAR,DCOV,DQDPAR,1,6,6,1)
C          IF((PARSIG.LT.0).AND.(PARSIG.GT.-1.0E8)) PARSIG = 0.0
          IF(PARSIG.GE.0.0) GO TO 79
          BARB = -SQRT(-PARSIG/(4.0*DSQAB))
          PARSIG=0.0
          WRITE(NOUT,1079) BARB
 1079 FORMAT(19X,' ********** NON-POS.DEF.COVARIANCE FOUND. SIGMA(DIST) 
     1OF MAGNITUDE',F9.5,' THROWN OUT ')

   79     DO 80 I=1,3
              CALL MULTI(DQDPAR(I),DELAB,DMTDCL(1,1,I),DELAB,1,3,3,1)
   80     CONTINUE
          DQDPAR(4) = 2.0*CELL(2)*CELL(3)*DELAB(2)*DELAB(3)
          DQDPAR(5) = 2.0*CELL(1)*CELL(3)*DELAB(1)*DELAB(3)
          DQDPAR(6) = 2.0*CELL(1)*CELL(2)*DELAB(1)*DELAB(2)

          CALL MULTI(CELSIG,DQDPAR,CELCOV,DQDPAR,1,6,6,1)
C          IF((CELSIG.LT.0).AND.(CELSIG.GT.-1.0E8)) CELSIG = 0.0
          IF(CELSIG.GE.0.0) GO TO 81
          BARB = -SQRT(-CELSIG/(4.0*DSQAB))
          CELSIG = 0.0
          WRITE(NOUT,1080) BARB
 1080 FORMAT(' ********** SIGMA(DIST) DUE TO CELL ESD''S OF MAGNITUDE',
     1F9.5,' THROWN OUT.')
   81 continue
      end if 

      DIST = SQRT(DSQAB)

      if(isig.ne.0)
     1        SIGMA = SQRT(PARSIG + CELSIG)/(2.0*DIST)
      IF(ICENT.LE.0) IOUSYM = ISYM
      IF(ICENT.GT.0) IOUSYM = -ISYM

      if (name(ib).eq.namecheck) then
        do iii = 1,max-1
  
        if (nint(dist*10000).eq.nint(check(iii,1)*10000)) then
           if (nint(xb2(1)*10000).eq.nint(check(iii,2)*10000)
     1     .and.nint(xb2(2)*10000).eq.nint(check(iii,3)*10000)
     1     .and.nint(xb2(3)*10000).eq.nint(check(iii,4)*10000)) 
     1     flag=1
        end if
        end do
      else
c     ---   zero out the array   ---
        do iii = 1,4
           do iiii = 1,500
              check(iiii,iii)=0
           end do
        end do
        namecheck=name(ib)
        max = 1
      end if

      if (flag.eq.1) then
        flag = 0
      else
      if(isig.ne.0) then
         WRITE(NOUT,1001) ATEXT(NAME(IB)),DIST,SIGMA,IOUSYM,XB2
      else
         write(nout,3001) ATEXT(NAME(IB)),DIST,IOUSYM,XB2
      end if
3001  FORMAT(8X,'- ',A4,F9.5,38X,I3,' (',3F8.4,')' )
1001  FORMAT(8X,'- ',A4,F9.5,F8.5,30X,I3,' (',3F8.4,')' )
        check(max,1)=dist
        check(max,2)=xb2(1)
        check(max,3)=xb2(2)
        check(max,4)=xb2(3)
        max=max+1
      end if
          
 5555 IF(DSQAB.GT.SQAMAX) GO TO 100
      IF(NUMSTO.LE.0) GO TO 90
C            DO NOT'STO' ANY DUPLICATES
      DO 85 I=1,NUMSTO
      IF(IB.NE.NATSTO(I)) GO TO 85
      Q = 0.0
      DO 84 J=1,3
   84 Q = Q + ABS(XB2(J) - XBSTO(J,I))
      IF(Q.LT.0.00001) GO TO 100
   85 CONTINUE
   90 NUMSTO = NUMSTO + 1
      IF(NUMSTO.LE.100) GO TO 95
      WRITE(NOUT,1003)
 1003 FORMAT('  ***** ANGMAX IS TOO BIG - OVER 5,000 ANGLES ON THIS ATOM
     1 ALONE. - PROGRAM STOP  ****')
      IERR=1
      RETURN
C
   95 NATSTO(NUMSTO) = IB
      NSYSTO(NUMSTO) = IOUSYM
      DSQSTO(NUMSTO) = DSQAB
      DO 99 I=1,3
   99 XBSTO(I,NUMSTO) = XB2(I)
  100 TRNDX3 = TRNDX3 + 1.0
      IF(TRNDX3.LE.TRNLM3) GO TO 43
      TRNDX2 = TRNDX2 + 1.0
      IF(TRNDX2.LE.TRNLM2) GO TO 42
      TRNDX1 = TRNDX1 + 1.0
      IF(TRNDX1.LE.TRNLM1) GO TO 41
      IF(NCENT.LE.0.OR.ICENT.GE.1) GO TO 200
      ICENT = 1
      DO 110 I=1,3
  110 XB1(I) = -XB1(I)
      GO TO 30
  200 CONTINUE
C
C          END DISTS. & STO-ING, START ANGLES
C
      IF(NUMSTO.LT.2) GO TO 400

      if(isig.ne.0) then
       WRITE(NOUT,1010) ATEXT(NAME(IA)),(PARM(I,IA),I=1,3)
      else
       WRITE(NOUT,3010) ATEXT(NAME(IA)),(PARM(I,IA),I=1,3)
      end if
 3010 FORMAT(/' VERTEX  LEG1  LEG2   ANGLE       ',35X,'LEG1',29X,
     1  'LEG2'/ '  ',A4,30X,'AT INPUT = (',3F8.4,')' )
 1010 FORMAT(/' VERTEX  LEG1  LEG2   ANGLE  SIGMA',35X,'LEG1',29X,
     1  'LEG2'/ '  ',A4,30X,'AT INPUT = (',3F8.4,')' )
CC 3010 FORMAT(1H /'  VERTEX  LEG1  LEG2   ANGLE       '/ '  ',A4)
C ,35X,'LEG1',29X,
C     1  'LEG2'/ '0  ',A4,30X,'AT INPUT = (',3F8.4,')' )
CC 1010 FORMAT(1H /'  VERTEX  LEG1  LEG2   ANGLE  SIGMA'/ '  ',A4)
C  ,35X,'LEG1',29X,
C     1  'LEG2'/ '0  ',A4,30X,'AT INPUT = (',3F8.4,')' )
      ln1=0
      ln2=0
      max=1
      if(isig.ne.0) then
       DO 210 I=1,3
       DO 210 J=1,3
  210 ACOV(I,J) = DCOV(I,J)
      end if
      NMSTM1 = NUMSTO - 1
      DO 300 IIB=1,NMSTM1
      IB = NATSTO(IIB)
      IOSYMB = NSYSTO(IIB)
      ISYM = IABS(IOSYMB)
      DSQAB = DSQSTO(IIB)
      DO 215 I=1,3
      XB1(I) = XBSTO(I,IIB)
  215 DELAB(I) = XB1(I) - PARM(I,IA)
      if(isig.ne.0) then
C       CALL PULCOV(QMAT,CVMSTR,MAXPAR,IA,IB)
       CALL PULCOV(QMAT,IA,IB,IOF)
       CALL MULTI(QQMAT,UNITM,QMAT,SYMMAT(1,1,ISYM),3,3,3,3)
       IF(IOSYMB.GT.0) GO TO 219
       DO 217 I=1,3
       DO 217 J=1,3
  217  QQMAT(I,J) = -QQMAT(I,J)
  219  DO 220 J=1,3
       K = J + 3
       DO 220 I=1,3
       ACOV(I,K) = QQMAT(I,J)
  220  ACOV(K,I) = QQMAT(I,J)
C       CALL PULCOV(QMAT,CVMSTR,MAXPAR,IB,IB)
       CALL PULCOV(QMAT,IB,IB,IOF)
       CALL MULTI(QQMAT,SYMMAT(1,1,ISYM),QMAT,SYMMAT(1,1,ISYM),3,3,3,3)
       DO 225 J=1,3
       K = J + 3
       DO 225 I=1,3
       L = I + 3
  225  ACOV(L,K) = QQMAT(I,J)
      end if
      IIBP1 = IIB + 1
      DO 300 IIC = IIBP1,NUMSTO
      IC = NATSTO(IIC)
      IOSYMC = NSYSTO(IIC)
      JSYM = IABS(IOSYMC)
      DSQAC = DSQSTO(IIC)
      DO 230 I=1,3
      XC1(I) = XBSTO(I,IIC)
  230 DELAC(I) = XC1(I) - PARM(I,IA)
      if(isig.ne.0) then
       CALL PULCOV(QMAT,IA,IC,IOF)
       CALL MULTI(QQMAT,UNITM,QMAT,SYMMAT(1,1,JSYM),3,3,3,3)
       IF(IOSYMC.GT.0) GO TO 234
       DO 233 I=1,3
       DO 233 J=1,3
  233  QQMAT(I,J) = -QQMAT(I,J)
  234  DO 235 J=1,3
       K = J + 6
       DO 235 I=1,3
       ACOV(I,K) = QQMAT(I,J)
  235  ACOV(K,I) = QQMAT(I,J)
       CALL PULCOV(QMAT,IB,IC,IOF)
C       CALL PULCOV(QMAT,CVMSTR,MAXPAR,IB,IC)
       CALL MULTI(QQMAT,SYMMAT(1,1,ISYM),QMAT,SYMMAT(1,1,JSYM),3,3,3,3)
       IF((IOSYMB*IOSYMC).GT.0) GO TO 239
       DO 237 I=1,3
       DO 237 J=1,3
  237  QQMAT(I,J) = -QQMAT(I,J)
  239  DO 240 J=1,3
       K = J + 6
       DO 240 I=1,3
       L = I + 3
       ACOV(L,K) = QQMAT(I,J)
  240  ACOV(K,L) = QQMAT(I,J)
C       CALL PULCOV(QMAT,CVMSTR,MAXPAR,IC,IC)
       CALL PULCOV(QMAT,IC,IC,IOF)
       CALL MULTI(QQMAT,SYMMAT(1,1,JSYM),QMAT,SYMMAT(1,1,JSYM),3,3,3,3)
       DO 245 J=1,3
       K = J + 6
       DO 245 I=1,3
       L = I + 6
  245  ACOV(L,K) = QQMAT(I,J)
      end if
      OVMDSQ = 1.0/SQRT(DSQAB*DSQAC)
      CALL MULTI(DOT,DELAB,METRIC,DELAC,1,3,3,1)
      IF(ABS(DOT).LE.0.000001) DOT = 0.0
      COSANG = DOT*OVMDSQ
      IF(COSANG.LT.-1.0.AND.COSANG.GT.-1.00001) COSANG = -1.0
      IF(COSANG.GT.1.0.AND.COSANG.LT.1.00001) COSANG = 1.0
      IF(ABS(COSANG).LE.1.0) GO TO 250
      WRITE(NOUT,1011) ATEXT(NAME(IB)),IOSYMB,ATEXT(NAME(IC)),IOSYMC,
     1  COSANG
 1011 FORMAT(' **** ERROR ***  ',A4,'(',I3,') - ',A4,'(',I3,')  GIVE COS
     1INE =',F20.10)
      GO TO 300
  250 continue
      ANG = ACOS(COSANG)
      if(isig.ne.0) then
       Q = DOT/DSQAB
       QQ = DOT/DSQAC
       DO 255 I=1,3
       ERVECB(I) = (DELAC(I) - Q*DELAB(I))*OVMDSQ
  255  ERVECC(I) = (DELAB(I) - QQ*DELAC(I))*OVMDSQ
       CALL MULTI(DQDB,METRIC,ERVECB,UNITS,3,3,1,1)
       CALL MULTI(DQDC,METRIC,ERVECC,UNITS,3,3,1,1)
       DO 260 I=1,3
  260  DQDA(I) = -DQDB(I) - DQDC(I)
       CALL MULTI(PARSIG,DQDPAR,ACOV,DQDPAR,1,9,9,1)
       IF(PARSIG.GE.0.0) GO TO 261
       BARB = -SQRT(-PARSIG)
       PARSIG = 0.0
       WRITE(NOUT,1091) BARB,COSANG
 1091 FORMAT(' ********** SIGMA(COSINE(ANGLE)) DUE TO CELL ESD''S OF MAG
     1NITUDE',E10.2,' THROWN OUT.....COSINE =',F10.5)
  261  DO 265 K=1,3
       CALL MULTI(Q,ERVECB,DMTDCL(1,1,K),DELAB,1,3,3,1)
       CALL MULTI(QQ,ERVECC,DMTDCL(1,1,K),DELAC,1,3,3,1)
  265  DQDPAR(K) = 0.5*(Q + QQ)
       DQDPAR(4) = 0.5*CELL(2)*CELL(3)*(ERVECB(2)*DELAB(3) + ERVECB(3)*
     1 DELAB(2) + ERVECC(2)*DELAC(3) + ERVECC(3)*DELAC(2)  )
       DQDPAR(5) = 0.5*CELL(1)*CELL(3)*(ERVECB(1)*DELAB(3) + ERVECB(3)*
     1 DELAB(1) + ERVECC(1)*DELAC(3) + ERVECC(3)*DELAC(1)  )
       DQDPAR(6) = 0.5*CELL(1)*CELL(2)*(ERVECB(1)*DELAB(2) + ERVECB(2)*
     1 DELAB(1) + ERVECC(1)*DELAC(2) + ERVECC(2)*DELAC(1)  )
       CALL MULTI(CELSIG,DQDPAR,CELCOV,DQDPAR,1,6,6,1)
       IF((CELSIG.LT.0).AND.(CELSIG.GT.-1.0E8)) CELSIG = 0.0
       IF(CELSIG.GE.0.0) GO TO 268
       BARB = -SQRT(-CELSIG)
       CELSIG = 0.0
       WRITE(NOUT,1090) BARB,COSANG
 1090 FORMAT(' ********** NON-POS.-DEF. COVARIANCE FOUND. SIGMA(COSINE(A
     1NGLE)) OF MAGNITUDE',E10.2,' THROWN OUT....COSINE =',F10.5)
  268  SIGCOS = SQRT(PARSIG + CELSIG)
       SIGANG = 0.0
       QQ = 0.0
       IF(ABS(SIGCOS).LT.0.000001) GO TO 275
       Q = COSANG + SIGCOS
       IF(Q.GT.1.0.OR.Q.LT.-1.0) GO TO 270
       SIGANG = ABS(ANG - ACOS(Q))
  270  Q = COSANG - SIGCOS
       IF(Q.GT.1.0.OR.Q.LT.-1.0) GO TO 274
       QQ = ABS(ANG - ACOS(Q))
       IF(SIGANG.LT.QQ) SIGANG = QQ
  274  SIGANG = RAD*SIGANG
      end if
  275 continue
      ANG = RAD*ANG

      if (name(ib).eq.ln1.and.name(ic).eq.ln2) then
        do iii = 1,maxa-1

        if (nint(ang*10000).eq.nint(testang(iii,1)*10000)) then
           if (nint(xb1(1)*10000).eq.nint(testang(iii,2)*10000)
     1     .and.nint(xb1(2)*10000).eq.nint(testang(iii,3)*10000)
     1     .and.nint(xb1(3)*10000).eq.nint(testang(iii,4)*10000)
     1     .and.nint(xc1(1)*10000).eq.nint(testang(iii,5)*10000)
     1     .and.nint(xc1(2)*10000).eq.nint(testang(iii,6)*10000)
     1     .and.nint(xc1(3)*10000).eq.nint(testang(iii,7)*10000))
     1      aflag=1
        end if
        end do
      else
        ln1=name(ib)
        ln2=name(ic)
        maxa = 1
      end if

      if (aflag.eq.1) then
        aflag = 0
      else
      if(isig.ne.0) then
      WRITE(NOUT,1012) ATEXT(NAME(IB)),ATEXT(NAME(IC)),ANG,SIGANG
     1 ,IOSYMB,XB1,IOSYMC,XC1
      else
      WRITE(NOUT,3012) ATEXT(NAME(IB)),ATEXT(NAME(IC)),ANG
     1 ,IOSYMB,XB1,IOSYMC,XC1
CC 3012 FORMAT(8X,'- ',A4,2X,A4,F8.2)
C     ,37X,2(I6,' (',3F8.4,')' ) )
CC 1012 FORMAT(8X,'- ',A4,2X,A4,F8.2,F7.2,30X)
C     ,2(I6,' (',3F8.4,')' ) )
 3012 FORMAT(8X,'- ',A4,2X,A4,F8.2,17X,2(I6,' (',3F8.4,')' ) )
 1012 FORMAT(8X,'- ',A4,2X,A4,F8.2,F7.2,10X,2(I6,' (',3F8.4,')' ) )
      end if
        testang(maxa,1)=ang
        testang(maxa,2)=xb1(1)
        testang(maxa,3)=xb1(2)
        testang(maxa,4)=xb1(3)
        testang(maxa,5)=xc1(1)
        testang(maxa,6)=xc1(2)
        testang(maxa,7)=xc1(3)
        maxa=maxa+1
        end if

  300 CONTINUE
  400 CONTINUE
      RETURN
      END
      
c	SUBROUTINE LATCEN
c	REAL METRIC
c	COMMON/A1/NATOMS,MAXPAR,SQDMAX,SQAMAX,NSYM,NCENT,ICNTL,ICOR,NLATT,
c	1 TRNLM1,TRNLM2,TRNLM3,CELL(6),CELSTR(6),METRIC(3,3),CELCOV(6,6),
c     2 DMTDCL(3,3,3),SYMMAT(3,3,96),SYMVEC(3,96),NAME(100),PARM(3,100),
c     3 CVMSTR(45150)
C-----
C-----ROUTINE TO ADD LATTICE CENTERING EQUIPOINTS TO THE EXISTING
C-----EQUIPOINT ARRAY
C-----
c      LSYM=NSYM
c      GO TO (6,6,1,2,3,1,4,6,5),NLATT
C-----A-CENTERING (&F-CENTERING)
c    1 CONTINUE
c      DO 10 I=1,LSYM
c      J=NSYM+I
c      SYMVEC(1,J)=SYMVEC(1,I)
c      SYMVEC(2,J)=0.5+SYMVEC(2,I)
c     IF(SYMVEC(2,J).EQ.1.0) SYMVEC(2,J)=0.0
c     SYMVEC(3,J)=0.5+SYMVEC(3,I)
c      IF(SYMVEC(3,J).EQ.1.0) SYMVEC(3,J)=0.0
c     DO 8 M=1,3
c      DO 8 N=1,3
c      SYMMAT(M,N,J)=SYMMAT(M,N,I)
c    8 CONTINUE
c   10 CONTINUE
c      NSYM=J
c      IF(NLATT.EQ.6) GO TO 2
c      GO TO 6
C-----B-CENTERING (& F-CENTERING)
c    2 CONTINUE
c      DO 20 I=1,LSYM
c      J=NSYM+I
c      SYMVEC(1,J)=0.5+SYMVEC(1,I)
c      IF(SYMVEC(1,J).EQ.1.0) SYMVEC(1,J)=0.0
c      SYMVEC(2,J)=SYMVEC(2,I)
c      SYMVEC(3,J)=0.5+SYMVEC(3,I)
c      IF(SYMVEC(3,J).EQ.1.0) SYMVEC(3,J)=0.0
c      DO 18 M=1,3
c      DO 18 N=1,3
c      SYMMAT(M,N,J)=SYMMAT(M,N,I)
c   18 CONTINUE
c   20 CONTINUE
c      NSYM=J
c      IF(NLATT.EQ.6) GO TO 3
c      GO TO 6
C-----C-CENTERING (& F-CENTERING)
c    3 CONTINUE
c      DO 30 I=1,LSYM
c      J=NSYM+I
c      SYMVEC(1,J)=0.5+SYMVEC(1,I)
c      IF(SYMVEC(1,J).EQ.1.0) SYMVEC(1,J)=0.0
c      SYMVEC(2,J)=0.5+SYMVEC(2,I)
c      IF(SYMVEC(2,J).EQ.1.0) SYMVEC(2,J)=0.0
c      SYMVEC(3,J)=SYMVEC(3,I)
c      DO 28 M=1,3
c      DO 28 N=1,3
c      SYMMAT(M,N,J)=SYMMAT(M,N,I)
c   28 CONTINUE
c   30 CONTINUE
c      NSYM=J
c      GO TO 6
C-----I-CENTERING
c    4 CONTINUE
c      DO 40 I=1,LSYM
c      J=NSYM+I
c      SYMVEC(1,J)=0.5+SYMVEC(1,I)
c      IF(SYMVEC(1,J).EQ.1.0) SYMVEC(1,J)=0.0
c      SYMVEC(2,J)=0.5+SYMVEC(2,I)
c      IF(SYMVEC(1,J).EQ.1.0) SYMVEC(2,J)=0.0
c      SYMVEC(3,J)=0.5+SYMVEC(3,I)
c      IF(SYMVEC(3,J).EQ.1.0) SYMVEC(3,J)=0.0
c      DO 38 M=1,3
c      DO 38 N=1,3
c      SYMMAT(M,N,J)=SYMMAT(M,N,I)
c   38 CONTINUE
c   40 CONTINUE
c      NSYM=J
c      GO TO 6
C-----HEXAGONAL SETTING OF AN R-CENTERED CELL
c    5 CONTINUE
c      Q=1.0/3.0
c      QQ=2.0/3.0
c      DO 50 I=1,LSYM
c      J=NSYM+I
c      SYMVEC(1,J)=Q+SYMVEC(1,I)
c      SYMVEC(2,J)=QQ+SYMVEC(2,I)
c      SYMVEC(3,J)=QQ+SYMVEC(3,I)
c      K=NSYM+NSYM+I
c      SYMVEC(1,K)=QQ+SYMVEC(1,I)
c      SYMVEC(2,K)=Q+SYMVEC(2,I)
c      SYMVEC(3,K)=Q+SYMVEC(3,I)
c      DO 48 M=1,3
c      DO 48 N=1,3
c      SYMMAT(M,N,J)=SYMMAT(M,N,I)
c      SYMMAT(M,N,K)=SYMMAT(M,N,I)
c   48 CONTINUE
c   50 CONTINUE
c      NSYM=K
C-----RETURN FOR PRIMATIVE AND RHOMBOHEDRAL LATTICES
c    6 CONTINUE
c      RETURN
c      END
      
      SUBROUTINE TOFSTN(ILOC)
      INCLUDE 'param.inc'
      REAL METRIC
      COMMON/A1/NATOMS,MPX,SQDMAX,SQAMAX,NSYM,NCENT,ICNTL,ICOR,NLATT,
     1 TRNLM1,TRNLM2,TRNLM3,CELL(6),CELSTR(6),METRIC(3,3),CELCOV(6,6),
     2 DMTDCL(3,3,3),SYMMAT(3,3,96),SYMVEC(3,96),NAME(NATS),
     3 PARM(3,NATS)
C,CVMSTR(45150)
      COMMON /COMUN/ SIGCEL(6),SIGPAR(3,NATS)
      COMMON /INOUT/ NOUT !NIN,NOUT,NTAP,NTOF
      COMMON /ERRORC/ IERR,isig
      DIMENSION CORLIN(45150),NROW(NATS*3)
      DATA NPMX/45150/,MXAT/NATS/,MXSY/24/
C-----
C-----ROUTINE TO READ INPUT FILE FROM TOFLS (ON UNIT 18) AND CONSTRUCT
C-----ATOMIC-POSITIONS CORRELATION MATRIX, IF NECESSARY
C-----
      NCLCOR = 1
      DO 4 J=1,MXAT
      DO 4 I=1,3
      PARM(I,J)=0.0
      SIGPAR(I,J)=0.0
    4 CONTINUE
      DO 5 K=1,96
      DO 5 I=1,3
      SYMVEC(I,K)=0.0
      DO 5 J=1,3
      SYMMAT(I,J,K)=0.0
    5 CONTINUE
C-----   May need to make adjustments !!!!!!!!!!!!!!!
C      READ(NTOF,100) NATOMS,NSYM,NCENT,ICOR,NPAR,NCLCOR
C  100 FORMAT(16I5)
      IF(NATOMS.LE.MXAT) GO TO 6
C      WRITE(NOUT,1001) NATOMS,MXAT
C 1001 FORMAT('0  ***',I10,' ATOMS INPUT FROM TOFLS',
C     1 ' -- ROOM FOR ONLY',I10,' -- PROGRAM ABORT  ***')
      IERR=1
      RETURN
    6 CONTINUE
      IF(NSYM.LE.MXSY) GO TO 8
C      WRITE(NOUT,1002) NSYM,MXSY
C 1002 FORMAT('0  ***',I10,' EQUIVALENT POSITIONS INPUT FROM TOFLS',
C     1 ' -- ROOM FOR ONLY',I10,' -- PROGRAM ABORT  ***')
      IERR=1
      RETURN
    8 CONTINUE
      MPX=3*NATOMS
C	  Make sure these are done!!!!!!!!!!!!!!!!!!!!
C      READ(NTOF,101) CELL,SIGCEL
C  101 FORMAT(3F10.5,3F10.4)
      do i=1,6
        if(sigcel(i).ne.0.0) isig=isig+1
      end do
      IF(NCLCOR.EQ.0) GO TO 9
C        Again!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C      READ(NTOF,102) ((CELCOV(I,J),J=I,6),I=1,6)
C  102 FORMAT(8F10.5)
      DO 7 I=1,6
      K=I+1
      DO 7 J=K,6
      CELCOV(J,I)=CELCOV(I,J)
    7 CONTINUE
    9 CONTINUE
C       These have to be taken care of!!!!!!!!!!!!!!!!!!!
C      READ(NTOF,103) (NAME(IA),(PARM(I,IA),I=1,3),(SIGPAR(I,IA),I=1,3),
C     1 IA=1,NATOMS)
C  103 FORMAT(A4,6X,6F10.5)
      do ia=1,natoms
         do i=1,3
            if(sigpar(i,ia).ne.0.0) isig=isig+1
         end do
      end do
C		Make sure !!!!!!!!!!!!!!!!!!!!!!!!!
C      READ(NTOF,104) (((SYMMAT(I,J,K),J=1,3),I=1,3),(SYMVEC(I,K),I=1,3),
C     1 K=1,NSYM)
C  104 FORMAT(9F5.0,5X,3F10.5)
      if(isig.eq.0) icor = 0
      IF(ICOR.LE.0) GO TO 65
      NCOR=(NPAR*NPAR+NPAR)/2
      IF(NCOR.LE.NPMX) GO TO 10
C      WRITE(NOUT,1000) NCOR,NPMX
C 1000 FORMAT('0  ***',I10,' CORRELATION COEFFICIENTS INPUT FROM TOFLS',
C     1 ' -- ROOM FOR ONLY',I10,' -- PROGRAM ABORT  ***')
      IERR=1
      RETURN
   10 CONTINUE
C		Again!!!!!!!!!!!!!!!!!!!!!!!!
C      READ(NTOF,105) (NROW(I),I=1,MPX)
C  105 FORMAT(3I5)
C      DO 15 I=1,NPMX
C      CORLIN(I)=0.0
C      CVMSTR(I)=0.0
C   15 CONTINUE
C		Again !!!!!!!!!!!!!!!!!!!!!!!!!
C      READ(NTOF,106) (CORLIN(I),I=1,NCOR)
C  106 FORMAT(16F5.2)
C-----
C      IA=0
C      ILOC=1
C   20 CONTINUE
C      IA=IA+1
C      IF(IA.GT.MPX) GO TO 60
C      NR=NROW(IA)
C      DO 50 IB=IA,MPX
C      NC=NROW(IB)
C      IF(NR.NE.0.AND.NC.NE.0) GO TO 30
C      IF(IA.EQ.IB) CVMSTR(ILOC)=1.0
C      IF(IA.NE.IB) CVMSTR(ILOC)=0.0
C      ILOC=ILOC+1
C      GO TO 50
C   30 CONTINUE
C      NLOC=0
C      IC=NR-1
C      IF(IC.EQ.0) GO TO 45
C      DO 40 ID=1,IC
C      NLOC=NLOC+(NPAR+1)-ID
C   40 CONTINUE
C   45 CONTINUE
C      NLOC=NLOC+(NC-IC)
C      CVMSTR(ILOC)=CORLIN(NLOC)
C      ILOC=ILOC+1
C   50 CONTINUE
C      GO TO 20
C   60 CONTINUE
C      ILOC=ILOC-1
C      GO TO 90
   65 CONTINUE
C-----
C      DO 67 I=1,NPMX
C      CVMSTR(I)=0.0
C   67 CONTINUE
C      N=1
C      ILOC=0
C   70 CONTINUE
C      IF(N.GT.MPX) GO TO 90
C      DO 80 I=N,MPX
C      ILOC=ILOC+1
C      IF(I.NE.N) GO TO 75
C      CVMSTR(ILOC)=1.0
C      GO TO 80
C   75 CONTINUE
C      CVMSTR(ILOC)=0.0
C   80 CONTINUE
C      N=N+1
C      GO TO 70
C   90 CONTINUE
C      RETURN
      END
